#include	<stdio.h>
#include	<math.h>
#include	<stdlib.h>
#include        <sys/types.h>
#include        <sys/times.h>
#include        <cm/cmmd.h>

#define		EPS		1.0e-2

int             nproc, procid, LEVEL, AVG, lower, upper;

void    simp1(a, mm, ll, nll, iabf, kp, bmax)
float   **a;
int     mm;
int     *ll;
int     nll;
int     iabf;
int     *kp;
float   *bmax;
{
 int    k, k1, itmp;
 float  test, BMAX, tmp_bmax;


  *kp = ll[1];
  k1 = 1;
  if ((lower <= (*kp+1)) && (upper > (*kp+1))) {
    *bmax = a[mm+1][*kp+1-lower];
    CMMD_bc_to_nodes(bmax,sizeof(float));
  }
  else
    CMMD_receive_bc_from_node(bmax,sizeof(float));

  for (k=2; k<=nll; k++) {
    if ((lower <= (ll[k]+1)) && (upper > (ll[k]+1))) {
      if (iabf == 0) 
        test = a[mm+1][ll[k]+1-lower]-(*bmax);
      else
        test = fabs(a[mm+1][ll[k]+1-lower])-fabs(*bmax);
      if (test > 0.0) {
        *bmax = a[mm+1][ll[k]+1-lower];
        k1 = k;
      }
    }
  }

  if (iabf == 0) tmp_bmax = *bmax;
  else           tmp_bmax = fabs(*bmax);

  BMAX = CMMD_reduce_float(tmp_bmax, CMMD_combiner_fmax);
  if (BMAX > tmp_bmax) k1 = nll+1;
  itmp = CMMD_reduce_int(k1, CMMD_combiner_min);

  if (k1 == itmp) CMMD_bc_to_nodes(bmax, sizeof(float));
  else            CMMD_receive_bc_from_node(bmax, sizeof(float));

  *kp = ll[itmp];
/*
    CMMD_sync_with_nodes();
    if (procid == 0) printf("simp 1 : bmax=%f kp=%d nll=%d mm=%d  %2d\n",
	*bmax, *kp, nll, mm, iabf);
    CMMD_sync_with_nodes();
*/
}

void    simp2(a, n, l2, nl2, ip, kp, q1)
float   **a;
int     n;
int     *l2;
int     nl2;
int     *ip;
int     kp;
float   *q1;
{
 int    k, ii, i, itmp;
 float  qp, q0, q, ftmp;
 float  *tmp, *tmp1;
/*
    CMMD_sync_with_nodes();
    if (procid == 0) printf("simp 2 !!\n");
    CMMD_sync_with_nodes();
*/
  tmp = (float *) malloc((nl2+1)*sizeof(float));
  tmp1 = (float *) malloc((nl2+1)*sizeof(float));

  if ((lower <= kp+1) && (upper > kp+1)) {
    for (i=1; i<=nl2; i++)
      tmp[i] = a[l2[i]+1][kp+1-lower];
    CMMD_bc_to_nodes(tmp, (nl2+1)*sizeof(float));
  }
  else
    CMMD_receive_bc_from_node(tmp, (nl2+1)*sizeof(float));

  if ((lower <= 1) && (upper > 1)) {
    for (i=1; i<=nl2; i++)
      tmp1[i] = a[l2[i]+1][1-lower];
    CMMD_bc_to_nodes(tmp1, (nl2+1)*sizeof(float));
  }
  else
    CMMD_receive_bc_from_node(tmp1, (nl2+1)*sizeof(float));

  *ip = 0;
  for (i=1; i<=nl2; i++) {
    if (tmp[i] < -EPS) {
      *q1 = -tmp1[i]/tmp[i];
      *ip = l2[i];
      ftmp = tmp[i];
      for (i=i+1; i<=nl2; i++) {
        ii = l2[i];
        if (tmp[i] < -EPS) {
          q = -tmp1[i]/tmp[i];
          if (q < *q1) {
            *ip = ii;
            *q1 = q;
          } else if (q == *q1) {
                   if ((lower <= 2) && (upper > 2)) 
                     for (k=2-lower; k<upper-lower; k++) {
                       qp = -a[*ip+1][k]/ftmp;
                       q0 = -a[ii+1][k]/tmp[i];
                       if (q0 != qp) break;
                     }
                   else {
                     if (lower > 2) 
                       for (k=0; k<upper-lower; k++) {
                         qp = -a[*ip+1][k]/ftmp;
                         q0 = -a[ii+1][k]/tmp[i];
                         if (q0 != qp) break;
                       }
                   }
   
                   itmp = 0; 
                   if (q0 < qp) itmp = 1;
                   if (CMMD_reduce_int(itmp, CMMD_combiner_add)) *ip = ii;
                    
                 }
        }
      }
    }
  }
  free(tmp);
  free(tmp1);
/*
    CMMD_sync_with_nodes();
    if (procid == 0) printf("SIMP 2 : n=%d nl2=%d ip=%d kp=%d q1=%f\n",
	n,nl2,*ip,kp,*q1);
    CMMD_sync_with_nodes();
*/
}

void    simp3(a, i1, k1, ip, kp)
float   **a;
int     i1, k1, ip, kp;
{
 int    kk, ii;
 float  piv;
 float	*tmp;

  tmp = (float *) malloc((i1+2)*sizeof(float));

  if ((lower <= kp+1) && (upper > kp+1)) {
    piv = 1.0/a[ip+1][kp+1-lower];
    tmp[ip+1] = piv;

    for (ii=1; ii<=ip; ii++) {
      a[ii][kp+1-lower] *= piv;
      tmp[ii] = a[ii][kp+1-lower];
    }
    for (ii=ip+2; ii <=i1+1; ii++) {
      a[ii][kp+1-lower] *= piv;
      tmp[ii] = a[ii][kp+1-lower];
    }

    CMMD_bc_to_nodes(tmp, (i1+2)*sizeof(float));

    for (ii=1; ii<=ip; ii++) {
      for (kk=0; kk<=kp-lower; kk++)
          a[ii][kk] -= (a[ip+1][kk]*tmp[ii]);
      for (kk=kp-lower+2; kk<upper-lower; kk++)
          a[ii][kk] -= (a[ip+1][kk]*tmp[ii]);
    }

    for (ii=ip+2; ii<=i1+1; ii++) {
      for (kk=0; kk<=kp-lower; kk++)
          a[ii][kk] -= (a[ip+1][kk]*tmp[ii]);
      for (kk=kp-lower+2; kk<upper-lower; kk++)
          a[ii][kk] -= (a[ip+1][kk]*tmp[ii]);
    }
    a[ip+1][kp+1-lower] = piv;

    for (kk=0; kk<=kp-lower; kk++)
      a[ip+1][kk] *= (-piv);
    for (kk=kp-lower+2; kk<upper-lower; kk++)
      a[ip+1][kk] *= (-piv);
  }
  else {
    CMMD_receive_bc_from_node(tmp, (i1+2)*sizeof(float));

    for (ii=1; ii<=ip; ii++)       
      for (kk=0; kk<upper-lower; kk++)
        a[ii][kk] -= (a[ip+1][kk]*tmp[ii]);

    for (ii=ip+2; ii<=i1+1; ii++) 
      for (kk=0; kk<upper-lower; kk++)
        a[ii][kk] -= (a[ip+1][kk]*tmp[ii]);

    piv = tmp[ip+1];
    for (kk=0; kk<upper-lower; kk++)
      a[ip+1][kk] *= (-piv);
  }

  free(tmp);
/*
    CMMD_sync_with_nodes();
    if (procid == 0) printf("simp 3 : i1=%d k1=%d ip=%d kp=%d %f\n",
        i1,k1,ip,kp,a[i1+1][1]);
    CMMD_sync_with_nodes();
*/

}

void    simplx(a, m, n, m1, m2, m3, icase, izrov, iposv)
float   **a;
int     m, n, m1, m2, m3;
int     *icase;
int     *izrov, *iposv;
{
 int    i, ip, ir, is, k, kh, kp, m12, nl1, nl2;
 int    *l1, *l2, *l3;
 float  q1, bmax, ftmp;

  if (m != (m1+m2+m3)) {
    printf("Bad input constraint counts in simplx\n");
    exit();
  }
  l1 = (int *) malloc((n+2)*sizeof(int));
  l2 = (int *) malloc((m+1)*sizeof(int));
  l3 = (int *) malloc((m+1)*sizeof(int));
  nl1 = n;
  for (k=1; k<=n; k++)
    l1[k] = izrov[k] = k;
  nl2 = m;

  if ((lower <= 1) && (upper > 1))
    for (i=1; i<=m; i++) 
      if (a[i+1][1] < 0.0) {
        printf("Bad input tableau in simplx\n");
        free(l1);
        free(l2);
        free(l3);
        exit();
      }

  for (i=1; i<=m; i++) {
    l2[i] = i;
    iposv[i] = n+i;
  }

  for (i=1; i<=m2; i++) l3[i] = 1;
  ir = 0;

  if (m2+m3) {
    ir = 1;
    for (k=0; k<upper-lower; k++) {
      q1 = 0.0;
      for (i=m1+1; i<=m; i++)
        q1 += a[i+1][k];
      a[m+2][k] = -q1;
    }
   do {
    simp1(a,m+1,l1,nl1,0,&kp,&bmax);

    if ((lower <= 1) && (upper > 1)) {
      ftmp = a[m+2][1];
      CMMD_bc_to_nodes(&ftmp,sizeof(float));
    }
    else
      CMMD_receive_bc_from_node(&ftmp,sizeof(float));

    if ((bmax <= EPS) && (ftmp < -EPS)) {
      *icase = -1;
      free(l1);
      free(l2);
      free(l3);
      return;
    } else if ((bmax <= EPS) && (ftmp <= EPS)) {
             m12 = m1+m2+1;
             if (m12 <= m) {
               for (ip=m12; ip<=m; ip++) {
                 if (iposv[ip] == (ip+n)) {
                   simp1(a,ip,l1,nl1,1,&kp,&bmax);
                   if (bmax > 0.0) goto one;
                 }
               }
             }
               ir = 0;
               --m12;
               if ((m1+1) <= m12)
                 for (i=m1+1; i<=m12; i++)
                   if (l3[i-m1] == 1)
                     for (k=0; k<upper-lower; k++)
                       a[i+1][k] = -a[i+1][k];
               break;
           }
    simp2(a,n,l2,nl2,&ip,kp,&q1);
    if (ip == 0) {
      *icase = -1;
      free(l1);
      free(l2);
      free(l3);
      return;
    }

one:
      simp3(a,m+1,n,ip,kp);
      if (iposv[ip] >= (n+m1+m2+1)) {
        for (k=1; k<=nl1; k++)
          if (l1[k] == kp) break;
        --nl1;
        for (is=k; is<=nl1; is++)
          l1[is] = l1[is+1];
        if ((lower <= (kp+1)) && (upper > (kp+1))) {
          ++a[m+2][kp+1-lower];
          for (i=1; i<=m+2; i++)
            a[i][kp+1-lower] = -a[i][kp+1-lower];
        }
      }
      else {
        if (iposv[ip] >= (n+m1+1)) {
          kh = iposv[ip]-m1-n;
          if (l3[kh]) {
            l3[kh] = 0;
            if ((lower <= (kp+1)) && (upper > (kp+1))) {
              ++a[m+2][kp+1-lower];
              for (i=1; i<=m+2; i++)
                a[i][kp+1-lower] = -a[i][kp+1-lower];
            }
          }
        }
      }
      is = izrov[kp];
      izrov[kp] = iposv[ip];
      iposv[ip] = is;
   } while (ir);
  }

  for (;;) {
    simp1(a,0,l1,nl1,0,&kp,&bmax);
    if (bmax <= 0.0) {
      *icase = 0;
      free(l1);
      free(l2);
      free(l3);
      return;
    }
    simp2(a,n,l2,nl2,&ip,kp,&q1);
    if (ip == 0) {
      *icase = 1;
      free(l1);
      free(l2);
      free(l3);
      return;
    }
    simp3(a,m,n,ip,kp);
    is = izrov[kp];
    izrov[kp] = iposv[ip];
    iposv[ip] = is;
  }
}

void 	main()
{
 float	**a; 
 int	n, m, m1, m2, m3, icase;
 int	*izrov, *iposv;
 int	i, j, k, quo, mod;
 FILE	*fid;
 float	tmp;
 double	time, time_lp;

  nproc = CMMD_partition_size();
  procid = CMMD_self_address();

  CMMD_fset_io_mode(stdout, CMMD_independent);
  CMMD_fset_io_mode(stderr, CMMD_independent);

  fid = fopen("input.dat","r");
  CMMD_fset_io_mode(fid, CMMD_independent);
  fscanf(fid,"%d%d%d%d%d",&n,&m,&m1,&m2,&m3);

  izrov = (int *) malloc((n+1)*sizeof(int));
  iposv = (int *) malloc((m+1)*sizeof(int));

  quo = (n+2)/nproc;
  mod = (n+2)%nproc;
  AVG = quo;

  if (procid < mod) {
    lower = procid*(quo+1);
    upper = lower+quo+1;
  }
  else {
    lower = (quo+1)*mod+(procid-mod)*quo;
    upper = lower+quo;
  }

  a = (float **) malloc((m+3)*sizeof(float *));
  for (i=0; i<m+3; i++)
    a[i] = (float *) malloc((upper-lower)*sizeof(float));

  for (i=1; i<m+3; i++)
    for (j=1; j<n+2; j++) 
      if ((j >= lower) && (j < upper))
        fscanf(fid,"%f",&a[i][j-lower]);
      else
        fscanf(fid,"%f",&tmp);

  fclose(fid);

  CMMD_sync_with_nodes();
  if (procid == 0) printf("Reading DONE !!\n");
  CMMD_sync_with_nodes();

/*
  for (i=1; i<m+3; i++) {
    for (j=1; j<n+2; j++)
      printf("%f ",a[i][j]);
    printf("\n");
  }
*/
  CMMD_node_timer_clear(0);
  CMMD_sync_with_nodes();
  CMMD_node_timer_start(0);

  simplx(a,m,n,m1,m2,m3,&icase,izrov,iposv);

  CMMD_node_timer_stop(0);
  time_lp = CMMD_node_timer_busy(0);
  time = CMMD_reduce_double(time_lp, CMMD_combiner_dmax);
  if ((procid == 0) && (icase == 0)) printf("Sloution is found\n\n");
  if (procid == 0) printf("LP time = %f seconds\n",time);

/*
  if (icase == 0) {
    printf("Sloutions are found\n\n");
    for (i=1; i<m+3; i++) {
      for (j=1; j<n+2; j++) 
        printf("%4f ",a[i][j]);
      printf("\n");
    }
    printf("izrov : \n");
    for (i=1; i<n+1; i++)
      printf("%3d ",izrov[i]);
    printf("\n");
    printf("iposv : \n");
    for (i=1; i<m+1; i++)
      printf("%3d ",iposv[i]);
    printf("\n");
  }
  else {
    printf("Unbounded value or no solution ! case : %d!\n",icase);
  }
*/
  if ((lower <= 1) && (upper > 1)) {
    printf("Processor %2d ================\n\n",procid);
    for (i=1; i<=m; i++)
      if ((iposv[i] <= n/2) && (a[i+1][1] > 0))
        printf("%5d  %f\n",iposv[i],a[i+1][1]);
  }

  free(izrov);
  free(iposv);
  for (i=0; i<m+3; i++)
    free(a[i]);
  free(a);
}
    


